--- chm_lib.c.orig	2004-05-01 09:22:41.000000000 +0800
+++ chm_lib.c	2004-05-01 09:19:32.000000000 +0800
@@ -1496,6 +1496,7 @@
     UChar *end;
     UChar *cur;
     unsigned long lenRemain;
+    UInt64 ui_path_len;
 
     /* the current ui */
     struct chmUnitInfo ui;
@@ -1528,12 +1529,15 @@
             if (! _chm_parse_PMGL_entry(&cur, &ui))
                 return 0;
 
+            /* get the length of the path */
+            ui_path_len = strlen(ui.path)-1;
+            
             /* check for DIRS */
-            if (ui.length == 0  &&  !(what & CHM_ENUMERATE_DIRS))
+            if (ui.path[ui_path_len] == '/'  &&  !(what & CHM_ENUMERATE_DIRS))
                 continue;
 
             /* check for FILES */
-            if (ui.length != 0  &&  !(what & CHM_ENUMERATE_FILES))
+            if (ui.path[ui_path_len] != '/'  &&  !(what & CHM_ENUMERATE_FILES))
                 continue;
 
             /* check for NORMAL vs. META */
@@ -1600,6 +1604,7 @@
     /* the current ui */
     struct chmUnitInfo ui;
     int flag;
+    UInt64 ui_path_len;
 
     /* the length of the prefix */
     char prefixRectified[CHM_MAX_PATHLEN+1];
@@ -1677,12 +1682,15 @@
             strcpy(lastPath, ui.path);
             lastPathLen = strlen(lastPath);
 
+            /* get the length of the path */
+            ui_path_len = strlen(ui.path)-1;
+            
             /* check for DIRS */
-            if (ui.length == 0  &&  !(what & CHM_ENUMERATE_DIRS))
+            if (ui.path[ui_path_len] == '/'  &&  !(what & CHM_ENUMERATE_DIRS))
                 continue;
 
             /* check for FILES */
-            if (ui.length != 0  &&  !(what & CHM_ENUMERATE_FILES))
+            if (ui.path[ui_path_len] != '/'  &&  !(what & CHM_ENUMERATE_FILES))
                 continue;
 
             /* check for NORMAL vs. META */
